"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var web_view_1 = require("tns-core-modules/ui/web-view");
var observable_1 = require("tns-core-modules/data/observable/observable");
var TNSWKWebView = (function (_super) {
    __extends(TNSWKWebView, _super);
    function TNSWKWebView() {
        var _this = _super.call(this) || this;
        _this._messageHandlers = [];
        _this._nativeChannels = [];
        return _this;
    }
    TNSWKWebView.prototype.addMessageHandler = function (messageHandlerName) {
        if (this.nativeView) {
            if (this._messageHandlers.indexOf(messageHandlerName) === -1) {
                var channel = this.nativeView.createWebMessageChannel();
                this._nativeChannels.push(channel);
                var weakRef_1 = new WeakRef(this);
                var callback = android.webkit.WebMessagePort.WebMessageCallback.extend({
                    onMessage: function (port, message) {
                        var owner = weakRef_1.get();
                        owner.notify({
                            eventName: TNSWKWebView.messageHandlerEvent,
                            object: observable_1.fromObject({
                                name: messageHandlerName,
                                body: message.getData()
                            })
                        });
                    }
                });
                var nativeArray = Array.create('android.webkit.WebMessagePort', 1);
                nativeArray[0] = channel[1];
                this.nativeView.postWebMessage(new android.webkit.WebMessage(messageHandlerName, nativeArray), android.net.Uri.EMPTY);
                channel[0].setWebMessageCallback(new callback());
                this._messageHandlers.push(messageHandlerName);
            }
        }
    };
    TNSWKWebView.prototype.removeMessageHandler = function (messageHandlerName) {
        var index = this._messageHandlers.indexOf(messageHandlerName);
        if (index > -1) {
            this._nativeChannels[index][0].close();
            this._nativeChannels.slice(index, 1);
            this._messageHandlers.splice(index, 1);
        }
    };
    TNSWKWebView.prototype.evaluateJavaScript = function (javaScriptString, callback) {
        if (this.nativeView) {
            var nativeView = this.nativeView;
            nativeView.evaluateJavascript(javaScriptString, new android.webkit.ValueCallback({
                onReceiveValue: function (value) {
                    callback(value, null);
                }
            }));
        }
    };
    return TNSWKWebView;
}(web_view_1.WebView));
TNSWKWebView.messageHandlerEvent = "message";
exports.TNSWKWebView = TNSWKWebView;
//# sourceMappingURL=webkit-webview.android.js.map